cryo_agent/publisher/routes/index.py
from flask import Blueprint, render_template
from sqlalchemy.orm import Session

import cryo_agent
from cryo_agent.logic.alerts import get_current_enabled_status
from cryo_agent.logic.clean import get_last_cleaned_time_ago
from cryo_agent.logic.nitrogen import get_last_filled_time_ago
from cryo_agent.logic.settings import get_fridge_name
from cryo_agent.publisher.db import get_engine

bp = Blueprint("index", __name__)


@bp.route("/", methods=["GET"])
def index():
    with Session(get_engine()) as session:
        return render_template(
            "index.html",
            version=cryo_agent.__version__,
            fridge_name=get_fridge_name(session),
            current_status=get_current_enabled_status(session),
            last_filled_ago=get_last_filled_time_ago(session),
            last_cleaned_ago=get_last_cleaned_time_ago(session),
        )

cryo_agent/publisher/templates/components/breadcrumbs.html
<div class="breadcrumbs">
    {% set breadcrumbs = (request.path | path_to_breadcrumbs) %}
    {% set ns = namespace(rel_paths = "/")%}
    {% if breadcrumbs | length > 1 %}
        <ol>
            {% for breadcrumb in breadcrumbs %}
                {% if loop.last %}
                    <li>
                        {{breadcrumb | capitalize}}
                    </li>
                {% else %}
                    <li>
                        {% set ns.rel_paths = ns.rel_paths + breadcrumb + "/"%}
                        <a href="{{ns.rel_paths}}">{{breadcrumb | capitalize}}</a><span class="ui-icon ui-icon-caret-1-e"></span>
                    </li>
                {% endif %}
            {% endfor %}
        </ol>
    {% endif %}
</div>

cryo_agent/publisher/templates/components/footer.html
<div class="footer">
    <h3> Copyright: QuTech {{ year() }}</h3>
</div>

cryo_agent/publisher/templates/components/header.html
<div class="header">
    <button id="toggleNavButton" class="openbtn">☰</button>
    <h1>CryoAgent</h1>
</div>

<script>
    // Setup navbar toggling
    $(function () {
        $("#toggleNavButton").on("click", () => {
            $(".container").toggleClass("navbar-visible");
        });
    })
</script>

cryo_agent/publisher/templates/components/navbar.html
<div id="navbar" class="navbar">
    <ul>
        <li>
            <a {% if "index"==active_page %} class="active" {% endif %} href="{{ url_for('index.index') }}">
                Overview
            </a>
        </li>
        <li>
            <a {% if "nitrogen"==active_page %} class="active" {% endif %} href="{{ url_for('nitrogen.nitrogen') }}">
                Nitrogen Trap Refill
            </a>
        </li>
        <li>
            <a {% if "clean"==active_page %} class="active" {% endif %} href="{{ url_for('clean.clean') }}">
                Nitrogen Trap Cleaning
            </a>
        </li>
        <li>
            <a {% if "alerts"==active_page %} class="active" {% endif %} href="{{ url_for('alerts.overview') }}">
                Alert Settings
            </a>
        </li>
        <li>
            <a {% if "logs"==active_page %} class="active" {% endif %} href="{{ url_for('logs.overview') }}">
                Logbook
            </a>
        </li>
        <li>
            <a {% if "latest"==active_page %} class="active" {% endif %}
               href="{{ url_for('latest_data.latest_data_view') }}">
                Latest Data
            </a>
        </li>
        <li>
            <a {% if "collectors"==active_page %} class="active" {% endif %} href="{{ url_for('collectors.index') }}">
                Collectors
            </a>
        </li>
        <li id="bottom-element">
            <a {% if "settings"==active_page %} class="active" {% endif %} href="{{ url_for('settings.index') }}">
                Settings
            </a>
        </li>
    </ul>
</div>